# yaml-language-server: $schema=../vendor/symfony/dependency-injection/Loader/schema/services.schema.json

# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.
# See also https://symfony.com/doc/current/service_container/import.html

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices.html#use-parameters-for-application-configuration
parameters:
    app.supabase_storage_bucket: '%env(string:SUPABASE_STORAGE_BUCKET)%'
    app.supabase_public_url: '%env(string:SUPABASE_PUBLIC_URL)%'
    app.public_url: '%env(string:APP_PUBLIC_URL)%'

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.

    Aws\S3\S3Client:
        class: Aws\S3\S3Client
        arguments:
            -
                credentials:
                    key: '%env(string:SUPABASE_S3_ACCESS_KEY)%'
                    secret: '%env(string:SUPABASE_S3_SECRET_KEY)%'
                region: '%env(string:SUPABASE_S3_REGION)%'
                version: 'latest'
                endpoint: '%env(string:SUPABASE_S3_ENDPOINT)%'
                use_path_style_endpoint: true
                signature_version: 'v4'
        public: false

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/'

    App\Service\JantePhotoStorage:
        arguments:
            $bucket: '%app.supabase_storage_bucket%'
            $publicUrl: '%app.supabase_public_url%'

    App\Service\JanteQrCodeGenerator:
        arguments:
            $publicUrl: '%app.public_url%'

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones
